package org.openjdk.sound;

import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Line;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.Mixer;
import javax.sound.sampled.SourceDataLine;

import junit.framework.TestCase;


public class OtherSoundProvidersAvailableTest extends TestCase{
	
	
	
	public void testOtherSoundProvers() {

		Mixer.Info mixerInfos [] = AudioSystem.getMixerInfo();
		Mixer.Info selectedMixerInfo = null;
		Mixer selectedMixer;
		
		int i = 0;
		for ( Mixer.Info info: mixerInfos) {
			System.out.println("Mixer Line " + i++ + ": " + info.getName() + " " + info.getDescription());
			if ( info.getName().contains("0,4")) {
				selectedMixerInfo =	info; 
			}
		}
		System.out.println(selectedMixerInfo.toString());
		System.out.println("getting information from selected mixer:");
		
		// use 0,4 or the default
		selectedMixer = AudioSystem.getMixer(selectedMixerInfo);
		System.out.println(selectedMixer.toString());
		try {
			Line.Info sourceDataLineInfo = null;
			
			selectedMixer.open();	// initialize the mixer
			
			Line.Info allLineInfo[] = selectedMixer.getSourceLineInfo();
			int j = 0;
			for ( Line.Info lineInfo : allLineInfo) {
				System.out.println("Source Line " + j++ + ": " + lineInfo.getLineClass());
				if ( lineInfo.getLineClass().toString().contains("SourceDataLine")) {
					sourceDataLineInfo = lineInfo;
				}
			}
			
			SourceDataLine sourceDataLine = (SourceDataLine) selectedMixer.getLine(sourceDataLineInfo);

			sourceDataLine.open();
			//sourceDataLine.write('a',  0, 2);
			sourceDataLine.close();
			
		} catch ( LineUnavailableException e ) {
			System.out.println("Line unavailable");
		}
		
		
		
	}
}
